
Redmine - Feature #6118

Filter by parent task or subtasks

2010-08-12 07:42 - Xagyg Wulf

Status: Closed Start date: 2010-08-12

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 3.1.0   

Resolution: Fixed   

Description

There doesn't seem to be an option to use "parent task" as a filter. I want to be able to select parent task as a filter and say "Parent

Task is null" - so that I get all top-level issues (as well as issues without any children).

Related issues:

Related to Redmine - Patch #6431: Allow parent task field to be used in filters Closed 2010-09-18

Related to Redmine - Feature #5325: Add Parent Task to 'Group Results By' dro... New 2010-04-15

Related to Redmine - Feature #6116: Group sub-tasks with parent on issue list New 2010-08-12

Related to Redmine - Feature #9992: Ability to filter issue subtasks in issue... New

Related to Redmine - Feature #10828: Request multiple distinct values includi... New

Related to Redmine - Feature #13054: Add the ability to filter issues on pare... Closed

Related to Redmine - Feature #22147: Change "Related issues" label for generi... Closed

Related to Redmine - Feature #33352: Enable inline issue autocomplete in issu... New

Related to Redmine - Feature #6958: Query Subtasks Closed 2010-11-22

Has duplicate Redmine - Feature #5728: Parent task field should be made avail... Closed 2010-06-22

Has duplicate Redmine - Feature #9592: Filtering by parent task Closed 2011-11-17

Has duplicate Redmine - Feature #10763: REST-API: Please add "parent_issue_id... Closed

Associated revisions

Revision 14304 - 2015-06-13 12:56 - Jean-Philippe Lang

Adds issue filters on parent/subtasks (#6118).

Revision 14305 - 2015-06-13 13:09 - Jean-Philippe Lang

Adds test for when filtering on invalid issue ids (#6118).

Revision 14310 - 2015-06-13 13:23 - Jean-Philippe Lang

Fixed test failure (#6118).

History

#1 - 2010-08-12 07:49 - Xagyg Wulf

Whoops - strike the bit in brackets "(as well as issues without any children)".

This is what I meant:

I want to be able to select parent task as a filter and say "Parent Task is null" - so that I get all top-level issues.

#2 - 2010-08-12 08:40 - Sepp _

+1

#3 - 2010-08-16 06:49 - Jeffrey Jones

+1 This would be a hugely useful feature for things like the Gantt chart where we want an overview.

#4 - 2010-08-30 17:06 - Anders Fältros

+1 Really would like to have this!
#5 - 2010-10-17 12:14 - Ewan Makepeace

+1

We have added a patch to sum all the estimated issues on the page, all the issues returned by the query and also those in each group when grouped.

Parent tasks are causing us to double (or triple) count some hours as they report the sum of all their child tasks (which may also be in the same list).

Even with a filter on Parent Task (which I support) I still have a problem - could there be a 'Has Child Tasks' filter as well perhaps?

#6 - 2010-10-22 16:47 - Emmanuel Toche

+1

#7 - 2010-10-22 17:32 - Sylvain Guimond

+1

#8 - 2010-12-15 03:58 - Charlie Chen

+1

#9 - 2011-04-07 11:09 - Martin Denizet (redmine.org team member)

My users don't like sub-tasking because they feel like it's making things more complicated and messy than before.

I think a "Is Parent" filter would really help them!

+1

#10 - 2011-05-24 01:00 - David Andrews

+1 please.

#11 - 2011-08-16 14:50 - Ruedi Silvestri

+1 also a patch would be much appreciated.

#12 - 2011-08-16 23:41 - Terence Mill

+1

#13 - 2011-08-29 10:55 - Lucas CORBEAUX

+1, such a filter would be really useful.

#14 - 2011-08-30 00:44 - Terence Mill

+1

#15 - 2011-08-30 13:45 - Etienne Massip

- Category set to Issues

#16 - 2011-09-13 16:15 - Matthias Neubert

+1 seems that there will be some progress regarding this issue, can you determine for which version number this is planed?

regards

Matthias

#17 - 2011-10-03 22:42 - Mischa The Evil

This feature was first requested via issue #5728. It was created by the UX-Team after UXTeamMeeting1 (see their meeting minutes, under "Core

Challenges Observed with Subtask Feature:", number 2).

I've just closed #5728 as a "duplicated by" of this issue since most of the (relevant) discussion has taken place here (as suggested by Colan

Schwartz).

#18 - 2011-11-21 05:06 - Mischa The Evil

- Target version set to Unplanned backlogs

This, along with #6116 / #5325, seems important things to improve handling of subtasks.

#19 - 2011-12-31 23:50 - Bartosz Cisek

+1
#20 - 2012-01-05 17:16 - Gokay Gok

+1

#21 - 2012-08-09 16:47 - Paweł Maruszczyk

+1

#22 - 2012-08-13 21:16 - Alexander Menshchikov

+1

#23 - 2012-08-29 13:29 - Tomas K

+1

#24 - 2012-09-13 13:06 - Hugo Zambotti

+1

#25 - 2012-09-25 13:14 - Florent Fievez

+1

#26 - 2012-10-03 14:54 - Fabrício Ferreira de Mendonça

+1

#27 - 2012-11-09 01:48 - Josh Hansen

+1

#28 - 2013-01-06 11:16 - Daniel Felix

Mischa The Evil wrote:

This, along with #6116 / #5325, seems important things to improve handling of subtasks.

 Agree! This could be handsome on greater projects with much subtasks.

#29 - 2013-01-09 11:15 - Thomas Lmx

+1

It seems to be the most important feature for my project !

#30 - 2013-01-21 15:52 - David Robinson

+1

#31 - 2013-01-23 12:44 - Dominik Follmann

Thomas Lmx wrote:

+1

It seems to be the most important feature for my project !

 same for us.

#32 - 2013-01-23 13:29 - Daniel Felix

Reference also #9992-8

#33 - 2013-01-25 10:48 - Alexey Efimov

+1 I'm interested in this feature also.

#34 - 2013-02-04 16:36 - Sylvain Just

+1 this feature will be very usefull for me too.

If anybody is interested, I also made a patch for display the parent subject and/or ID in email subject notification.

This information allow project manager to create template task with generic sub-tasks and copy it for recursives task.

Notifications by mail make more sense when subtask subject depends of parent subject.
Note : when task is just created, parent subject is unknown... so I display parent id instead of.

diff -r 64316d392708 -r 0f36159c4d63 app/models/mailer.rb

--- a/app/models/mailer.rb  Tue Jan 22 16:06:10 2013 +0100

+++ b/app/models/mailer.rb  Tue Jan 22 16:06:55 2013 +0100

@@ -43,9 +43,15 @@

     @issue_url = url_for(:controller => 'issues', :action => 'show', :id => issue)

     recipients = issue.recipients

     cc = issue.watcher_recipients - recipients

+   #s = "[#{issue.project.name} - #{issue.tracker.name} ##{issue.id}] (#{issue.status.name}) " 

+   s = "[#{issue.project.name} - " 

+   s << "#{issue.tracker.name} " if (issue.tracker.id != 4)

+   s << "##{issue.id}] (#{issue.status.name}) " 

+   s << "##{issue.parent_issue_id} > " if issue.parent_issue_id

+   s << "#{issue.subject}" 

     mail :to => recipients,

       :cc => cc, 

-      :subject => "[#{issue.project.name} - #{issue.tracker.name} ##{issue.id}] (#{issue.status.name}) #{issu

e.subject}" 

+      :subject => s

   end 

   # Builds a Mail::Message object used to email recipients of the edited issue.

@@ -65,8 +71,11 @@

     recipients = issue.recipients

     # Watchers in cc

     cc = issue.watcher_recipients - recipients

-    s = "[#{issue.project.name} - #{issue.tracker.name} ##{issue.id}] " 

+    s = "[#{issue.project.name} - " 

+   s << "#{issue.tracker.name} " if (issue.tracker.id != 4)

+   s << "##{issue.id}] " 

     s << "(#{issue.status.name}) " if journal.new_value_for('status_id')

+   s << "#{issue.parent.subject} - " if issue.parent

     s << issue.subject

     @issue = issue

     @journal = journal

 You can also patch your project to display parent subject instead of tracker and ID in issues list :

diff -r 70ce4d70b7e1 -r 61345a556b62 app/helpers/application_helper.rb

--- a/app/helpers/application_helper.rb Tue Jan 22 16:12:26 2013 +0100

+++ b/app/helpers/application_helper.rb Tue Jan 22 20:10:39 2013 +0100

@@ -64,10 +64,13 @@

   #   link_to_issue(issue, :truncate => 6)        # => Defect #6: This i...

   #   link_to_issue(issue, :subject => false)     # => Defect #6

   #   link_to_issue(issue, :project => true)      # => Foo - Defect #6

+  #   link_to_issue(issue, :title => subject)     # => This is the subject: Defect #6

+  #                                              # if 'id' or nil => default behavior

   #

   def link_to_issue(issue, options={})

     title = nil 

     subject = nil 

+   if options[:title] == nil || options[:title] == 'id'

     if options[:subject] == false

       title = truncate(issue.subject, :length => 60) 

     else

@@ -82,6 +85,18 @@

     s << h(": #{subject}") if subject

     s = h("#{issue.project} - ") + s if options[:project]

     s   

+   elsif options[:title] == 'subject'

+       subject = issue.subject

+       if options[:truncate]

+         subject = truncate(subject, :length => options[:truncate])

+       end

+       tracker = "#{h(issue.tracker)} ##{issue.id}" 

+       s = link_to subject, {:controller => "issues", :action => "show", :id => issue},

+                                                    :class => issue.css_classes,

+                                                    :title => tracker

+       s = h("#{issue.project} - ") + s if options[:project]

+       s

+   end

   end 

2025-07-04 4/8



   # Generates a link to an attachment.

diff -r 70ce4d70b7e1 -r 61345a556b62 app/helpers/queries_helper.rb

--- a/app/helpers/queries_helper.rb Tue Jan 22 16:12:26 2013 +0100

+++ b/app/helpers/queries_helper.rb Tue Jan 22 20:10:39 2013 +0100

@@ -72,7 +72,7 @@

     when 'FalseClass'

       l(:general_text_No)

     when 'Issue'

-      link_to_issue(value, :subject => false)

+      link_to_issue(value, {:subject => false, :title => 'subject'})

     else

       h(value)

     end

#35 - 2013-04-18 16:02 - André Schloemp

+1 we need this feature

#36 - 2013-06-18 09:42 - Vito Marolda

+1

#37 - 2013-07-26 09:28 - Sergio Tendero

+1

#38 - 2013-07-30 19:19 - loic Le Gallou

+1 (display should include indirect subtasks in order to see the full branches related to a top parent task)

#39 - 2013-08-02 14:00 - Artem Beloglazov

+1

#40 - 2013-09-03 16:14 - Jeffrey Clark

Patch in #10828 should resolve this issue.

#41 - 2013-09-04 03:26 - Toshi MARUYAMA

- Related to Feature #10828: Request multiple distinct values including issue id, parent_id, root_id added

#42 - 2014-04-02 05:11 - Maxime Vez

+1

#43 - 2014-10-05 12:06 - Laurent Dairaine

+1

#44 - 2014-10-16 18:54 - Felix Schäfer

- File 6118-add_parent_issue_id_filter_to_issue_query.patch added

Here is a patch that adds a filter for parent task on the issue list.

#45 - 2014-10-25 06:25 - Mischa The Evil

- Related to Feature #13054: Add the ability to filter issues on parent task. added

#46 - 2014-11-18 15:44 - Luis Ferrao

It's been 4 years and innumerable similar requests, this feature is as basic as it gets, what's the hold up?

#47 - 2014-11-24 17:12 - Vjacheslav Ryzhov

Luis Ferrao wrote:

It's been 4 years and innumerable similar requests, this feature is as basic as it gets, what's the hold up?

 subscribe to the issue
#48 - 2014-12-10 12:16 - David Marín Carreño

+1

#49 - 2015-02-03 10:11 - Baatar Sukhbaatar

+1

#50 - 2015-02-11 11:06 - Igor Pellegrini

+1

Any planned roadmap that could include this feature?

Would really improve my (and others) workflow.

Thanks.

#51 - 2015-02-12 13:56 - Daniel Felix

Our company uses many issues with many parent tasks. This feature would greatly improve our work with redmine, as we could filter all "master"

issues. This would be really great to see this in the next release.

#52 - 2015-02-13 07:21 - Mischa The Evil

- File rm6118-add_parent_issue_id_filter_to_issue_query-trunk_r13697.diff added

- Assignee set to Jean-Philippe Lang

- Target version changed from Unplanned backlogs to Candidate for next major release

A while ago I started a test of the patch Felix posted in #6118#note-44, therefor I started writing a solid test to back up the rather small code change.

I just finished extracting a patch (using git diff on a local dev branch, so don't mind the SHA's) from the older VM (source:/trunk@13697) I was

working on, which includes the change proposed by Felix (although slightly adjusted to match current code [the filter key double quoted, while single

quotes work just as fine here]) and an additional test (QueryTest#test_filter_on_parent_task_id) which covers the availability of the filter for issue

queries and tests the functionality of each of the operators that are available for integer type filters. With this patch applied (as said on 

source:/trunk@13697) all existing tests pass (mysql-only, without ldap, scm and ui), as so does the newly added test for this feature.

@Jean-Philippe: can you assess/review this feature and patch to see if it can still be included in 3.0.0? There is obviously a clear demand for this and

the change seems rather small and oversee-able, especially now that it includes a test.

#53 - 2015-03-02 14:36 - Sebastian Paluch

This is great feature but should be done as more complete and include filter by parent task, root task and is leaf. Those are all parent-child relations.

#54 - 2015-03-17 16:23 - txemi M

+1

I am patching production with Felix's patch, I would love it included in next release.

Useful for views of root tasks or child tasks of given task.

#55 - 2015-04-30 13:50 - Jaromír Rys

+1

#56 - 2015-05-18 09:41 - Maik Lindner

+1

#57 - 2015-06-10 10:43 - Florian ROBERT

+1

#58 - 2015-06-11 02:40 - Go MAEDA

- Target version changed from Candidate for next major release to 3.1.0

I tested Mischa The Evil's patch on current trunk (r14300) and it works fine.

Could it be in Redmine 3.1.0?

#59 - 2015-06-13 13:00 - Jean-Philippe Lang

- Subject changed from Filter by parent task to Filter by parent task or subtasks

- Status changed from New to Closed
- Resolution set to Fixed

Mischa's patch is nice and simple but it does not address all the posibilities requested here.

I've added 2 filters in r14304 to filter on parent and subtasks (these 2 filters can be combined):

parent

is XXX (=> lists child issues of XXX)

contains XXX (=> lists descendant issues of XXX)

none (=> lists root issues)

any (=> lists subtasks)

subtasks

is XXX (=> lists the parent of XXX, maybe not so usefull)

contains XXX (=> lists ancestors of XXX)

none (=> lists leaf issues)

any (=> lists parent issues)

#60 - 2015-06-15 06:56 - Go MAEDA

Thank you very much for implementing this!

#61 - 2015-06-18 10:50 - Sebastian Paluch

That is great, no more plugins!

The only option that seems to be missing under "subtasks" is ability to show issue hierarchy deep to some level. This is useful to see overall list of job

to do for a project to some level of details. (#20129)

#62 - 2015-06-18 16:21 - Colan Schwartz

Sebastian Paluch wrote:

The only option that seems to be missing under "subtasks" is ability to show issue hierarchy deep to some level. This is useful to see overall list

of job to do for a project to some level of details.

 Open another ticket for that (unless there is one already), and link to it from here.  Let's not cloud this fixed issue.

#63 - 2015-06-30 20:09 - Alex Petty

Jean-Philippe Lang wrote:

I've added 2 filters in r14304 to filter on parent and subtasks (these 2 filters can be combined):

 Excellent!! Thanks Jean-Philippe!!

#64 - 2015-08-20 09:27 - Regis Leneveu

This seems to be the solution for some user-requests in our company.

Could you explain - for the rest of us - HOW I could create a filter which shows a specific tasks an all his related subtasks in a hierarchy?

I just can't figure it ou.

Thanks, Régis

#65 - 2016-04-04 07:23 - Toshi MARUYAMA

- Related to Feature #22147: Change "Related issues" label for generic grouped query filters added

#66 - 2017-05-01 14:20 - Go MAEDA

- Has duplicate Feature #10763: REST-API: Please add "parent_issue_id" as filter for requests to filter out subtickets added

#67 - 2020-04-25 10:17 - Mischa The Evil

- Related to Feature #33352: Enable inline issue autocomplete in issue id query filter fields added

#68 - 2024-09-19 15:02 - Holger Just

- Related to Feature #6958: Query Subtasks added

Files

6118-add_parent_issue_id_filter_to_issue_query.patch 543 Bytes 2014-10-16 Felix Schäfer
rm6118-add_parent_issue_id_filter_to_issue_query-trunk_r13697.diff 2.94 KB 2015-02-13 Mischa The Evil
